import csv
from datetime import datetime
import scipy.sparse as sparse
import numpy as np
import xlrd
import pandas as pd
def unique(old_list):
    # Minimize the use_id and item_id in the dataset
    count = 1
    dic = {}
    for i in range(len(old_list)):
        if old_list[i] in dic:
            old_list[i] = dic[old_list[i]]
        else:
            dic[old_list[i]] = count
            old_list[i] = count
            count += 1
    return old_list




def datareader(dataset = './dataset/ml-la.csv'):
    with open(dataset) as f:
        reader=csv.reader(f)
        header_row=next(reader)
        row, column, value, timestamp= [], [], [],[]
        for data in reader:
            current_date = int(data[1])
            row.append(current_date)
            col = int(data[2])
            column.append(col)

            valu = int(float(data[3]))
            value.append(valu)

            time = (data[4])
            timestamp.append(time)
            # if(count>=25000):
            #     break

    row = unique(row)
    column = unique(column)
    numberOfUser = max(row)+1
    numberOfItem = max(column)+1

    column = unique(column)
    mtx = sparse.coo_matrix((value, (row, column)), shape=(numberOfUser, numberOfItem))
    mtx = mtx.todense()
    mtx = np.array(mtx)
    return numberOfUser, numberOfItem, mtx

def readerxls(dataset = './jester-data-2.xls') :
    data = pd.read_excel(dataset)
    var1 =np.array(data)
    biglist = []
    for i in range(len(var1)):
        smalllist=[]
        for j in range(len(var1[0])):
            if(j==0):
                continue
            elif(var1[i][j]==99):
                smalllist.append(0)
            else:
                if(int(var1[i][j]) == 0):
                    if(var1[i][j]>0):
                        var1[i][j] = 1
                    if (var1[i][j] < 0):
                        var1[i][j] = -1
                    if(var1[i][j] == 10):
                        var1[i][j] = 9
                smalllist.append((int(var1[i][j])))
        biglist.append( smalllist)
        # if(i>90000):
        #     break
    mtx = np.array(biglist)
    mtx = np.array(mtx)
    numberOfUser = mtx.shape[0]
    numberOfItem = mtx.shape[1]
    # print(mtx)
    # print(mdx)
    # print(numberOfUser,numberOfItem)
    return numberOfUser, numberOfItem, mtx

if __name__ == "__main__":
    datareader('./transratings.csv')

